
#ifndef HIN_CONF_H
#define HIN_CONF_H

#define HIN_CONF_PATH "workdir/main.lua"
#define HIN_LOGDIR_PATH "workdir/logs/"
#define HIN_WORKDIR_PATH "./"
#define HIN_TEMP_PATH "/tmp/"
#define HIN_DEBUG_MASK 0x20007

#define HIN_URING_QUEUE_DEPTH 4096
#define HIN_URING_DONT_FORK 0
#define HIN_URING_REDUCE_SYSCALLS 1
#define HIN_URING_EVENTS_PER_WAIT 256
#define HIN_PIPE_QUE_DEPTH 32

#define HIN_SOCKET_REUSEADDR 1

#define HIN_USE_SIGNAL_FD 1
#define HIN_RLIMIT_MEMLOCK ((long)262144)
#define HIN_RLIMIT_NOFILE ((long)4096)

// 1 for warning, 2 for program abort
#define HIN_RESTRICT_ROOT 1

#define HIN_HTTPD_TIMEOUT 10
// in miliseconds
#define HIN_HTTPD_TIME_DT 500
#define HIN_HTTPD_MAX_HEADER_SIZE 65000
#define HIN_HTTPD_MAX_HEADER_LINE_SIZE 4096
#define HIN_HTTPD_MAX_POST_SIZE 4121440
#define HIN_HTTPD_MAX_COMPRESS_SIZE 0
#define HIN_HTTPD_POST_DIRECTORY HIN_TEMP_PATH
#define HIN_HTTPD_CACHE_DIRECTORY "cache"
#define HIN_HTTPD_CACHE_CLEAN_ON_EXIT 1
#define HIN_HTTPD_CACHE_TMPFILE 0
#define HIN_HTTPD_CACHE_MAX_SIZE 64 * 1024 * 1024
#define HIN_HTTPD_SERVER_BANNER "hinsightd 0.9"
#define HIN_HTTPD_CONNECTION_REUSE 1
#define HIN_HTTPD_OVERLOAD_ERROR 1
#define HIN_HTTPD_ERROR_ON_MISSING_CERT 0
#define HIN_HTTPD_ERROR_MISSING_HOSTNAME 0 // http spec says you need this I say you don't
#define HIN_HTTPD_DEFAULT_MAX_CONNECTIONS 2000 // should be no more than half of HIN_RLIMIT_NOFILE if using proxy and can be about nofile - 100 otherwise, never more

#define HIN_HTTPD_DISABLE_POWERED_BY 0
#define HIN_HTTPD_CGI_CHUNKED_UPLOAD 0

#define HIN_HTTPD_ASYNC_OPEN 1
#define HIN_HTTPD_ASYNC_STATX 0

#define HIN_LINUX_BUG_5_11_3
#define HIN_LINUX_URING_DONT_HAVE_SIGNALFD
#define HIN_LINUX_URING_DONT_HAVE_NOTIFYFD

#endif

